( Random Number Generator )
( From Jounal of Forth Application and Research V-1 N-2 )

: DARRAY CREATE 4 * ALLOT DOES> SWAP 1- 4 * + ;

55 DARRAY RND
VARIABLE TALLY 0 TALLY !

2VARIABLE SEED 
314159296. SEED 2!

\ sets up cyclic index.
: CYCLE ( N1 A -- N2 )
  DUP >R @ 1+ DUP ROT > IF
    DROP 1
  THEN
  DUP R> ! ;

\ Cyclic index MOD 55.
: STEP ( A -- N+1 )
  55 TALLY CYCLE ;
  
\ Initialize array.
: RND.INIT ( -- )
  ( zero TALLY and initialize seed value )
  0 TALLY ! SEED 2@ 2DUP 55 RND 2!
  ( scattery values into array )
  1. 2SWAP 55 1 DO 
    2OVER 2DUP 21
    ( subtraction )
    I * 55 MOD RND 2! D- DUP 0 < IF
      ( make number positive )
      1000000000. D+
    THEN
    2SWAP 
  LOOP
  2DROP 2DROP ;
  
\ Next random number.
: RANDOM
  ( subtract I+31 term )
  STEP DUP >R RND 2@ 2DUP R@ DUP
  25 < IF
    31 +
  ELSE
    24 -
  THEN
  RND 2@ D- DUP 0 < IF
    1000000000. D+
  THEN
  R> RND 2! ;
  
: WARMUP ( -- )
  221 1 DO RANDOM 2DROP LOOP ;
  
: SETUP ( -- )
  0 TALLY ! RND.INIT WARMUP ;  