''Propeller Chip MV4th16 Using Direct I/O Demo
''
''All console and block I/O is handled by forth I/O COG.
''
''
''www.shaels.net
'
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  c_SystemCommandAdr = $7FFC    'Used to pass a system command and stack pointer address
                                'from forth COG to another spin or asm object that performs I/O.
                                'The variables are two word sized values (16 bits each).
                                'We store the variables at the end of the forth stack.
  c_DataStackBaseAdr = IO#c_IODataStartAdr - 8  'leave 8 bytes as a pad between data stack base and I/O variables
  
OBJ
  FORTH : "MV4th16"
  IO    : "IForthBaseIO"

PUB Start
      IO.start(31, 30, 0, 115200, c_SystemCommandAdr)
      FORTH.start(c_SystemCommandAdr, c_DataStackBaseAdr)
        