MARKER TERMINAL

80 VALUE at_rows
25 VALUE at_cols

: at-csi ( -- ) 27 EMIT [CHAR] [ EMIT ;

: at-byte ( c -- ) $FF AND 1 U.R ;

: at-semi ( -- ) [CHAR] ; EMIT ;

: at-xy! ( X Y -- ) SWAP 1+ SWAP 1+ at-csi at-byte at-semi at-byte [CHAR] H EMIT ;

: at-max-xy@ ( -- X Y) at_rows at_cols ;

: at-page ( -- )  at-csi 2 at-byte [CHAR] J EMIT ;

: at-eol ( -- ) at-csi ." 0K" ;

: at-cursor ( f -- ) at-csi IF ." ?25h" ELSE ." ?25l" THEN ;

: at-rxst ( -- c-adr u )
  BEGIN
    KEY [CHAR] [ =
  UNTIL
  PAD BEGIN 
    KEY [CHAR] R OVER <> IF
      DUP [CHAR] ; = IF
        DROP BL
      THEN  
      OVER C! 1+ FALSE
    ELSE
     ( all done )
     DROP PAD - PAD SWAP TRUE
    THEN
  UNTIL
; 
  
: at-xy@ ( -- X Y ) at-csi ." 6n" EMPTY-KEYS
  at-rxst EVALUATE 1- SWAP 1- ;

: at-intmax at-xy@ 160 160 at-xy! at-xy@ TO at_rows TO at_cols at-xy! ;

: tt-noecho ( -- ) $FF EMIT $84 EMIT ;

\ Use at>term to assign terminal functions to ansi driver words.
: at>term ( -- ) ['] at-xy! IS AT-XY ['] at-xy@ IS XY
  ['] at-page IS PAGE ['] at-eol IS CLR-EOL
  ['] at-max-xy@ IS MAX-XY ['] at-cursor IS CURSOR
  at-intmax ;
  
\ Use tt>term when ansi terminal is windows telnet client.
: tt>term ( -- )
  at>term tt-noecho ;
