MARKER IO-PINS

: get-bit ( uBit -- d )
  1. ROT DLSHIFT ;
  
: set-bit ( d uBit -- d' ) 
  get-bit DOR ;

: clr-bit ( d uBit -- d' )
  get-bit
  $FFFFFFFF. DXOR
  DAND ;

: reg-bit ( uBit fState reg --  )
  DUP >R COG@ ROT
  ( uBit dRegVal fState )
  IF 
    ( uBit dRegVal )
    ROT set-bit
  ELSE
    ROT clr-bit 
  THEN 
  R> COG! ;

: outa-bit ( uBit fState  )
  $1F4 reg-bit ;

: dira-bit ( uBit fState  )
  $1F6 reg-bit ;

: r-set ( f -- )
  #7 SWAP outa-bit
  #7 TRUE dira-bit ;
  

: r-on TRUE r-set ;

: r-off FALSE r-set ;
