( FORTH words to directly output to VGA or TV )

: vt-space ( -- )
  BL vt-emit ;

: vt-spaces ( uCount -- ) 
  DUP 0> IF 
    0 ?DO 
      vt-space 
    LOOP 
  ELSE 
    2DROP
  THEN ;

: vt-type ( c-adr uCount - )
  0 DO 
    DUP C@ vt-emit 1+ 
  LOOP 
  DROP ;

: vt-. ( n - )
  <# DUP ABS 0 #S ROT SIGN #> 
  vt-type vt-space ;

: vt-u. ( n - ) 
  <# 0 #S #> vt-type vt-space ;

: vt-ud. ( d - ) 
  <# #S #> vt-type vt-space ;

: vt-d.r ( d u - )
  >R SWAP OVER DABS <# #S ROT SIGN #>
  R> OVER - vt-spaces vt-type ;
  
: vt-d. ( d -- )
  0 vt-d.r vt-space ;

: vt-.r ( n - ) >R S>D R> vt-d.r ;

: vt-u.r ( u uCount -- ) 0 SWAP vt-d.r ;